/*
 * @file assassin.h
 * @author Tick
 * @license GPL
 */

#ifndef __OPENMOKO_INSTALLER_H__
#define __OPENMOKO_INSTALLER_H__
#define PACKAGE_NAME "Assassin"
#define THUMBNAIL_FILE	"thumbnail.eet"

#define MAX_PACKAGE_NAME_SIZE 1024

#define SCREEN_WIDTH		480
#define SCREEN_HEIGHT		568
#define SCREEN_COLOR		0x000000

// https://wiki.internal.openmoko.org/wiki/Image:Alert_confirmation_details.png

#define PROGRESSBAR_HEIGHT	120
#define PROGRESSBAR_WIDTH	480
#define PROGRESSBAR_COLOR	0x00ff00
#define PROGRESSBAR_TEXT_FONT  	"LiberationSans-Bold"
#define PROGRESSBAR_TEXT_SIZE	16
#define PROGRESSBAR_TEXT_COLOR	0xffffff
#define PROGRESSBAR_ALPHA	255


enum ActionType {
	INSTALL = 0,
	UPDATE,
	UNINSTALL,
};

enum ActionStatus {
	INITIAL = 0,
	WAITCONFIRM,
	DOWNLOADING,
	INSTALLING,
	UPDATING,
	UNINSTALLING,
	SUCCESS,
	FAILED
};

struct Target {
	enum ActionType type;
	enum ActionStatus status;
	char *package;
	int progress;
};



#endif
