#include <stdio.h>
#include <dummy.h>
#include <Ecore.h>
#include <Evas.h>
#include <Ecore_Evas.h>
#include <assassin.h>
#include <debug.h>
#include <gears.h>
#include <e_dbus_proxy.h>
#include <pkutil.h>


extern Ecore_Evas  *   ee;

static int __dummy_progressbar_free(void * data) {
	struct Installer_Progressbar * IP = (struct Installer_Progressbar * )data;
	free_Progressbar(IP);
	return 0;
}
static int __dummy_progressbar_timer(void  * data) {
	struct Installer_Progressbar * IP = (struct Installer_Progressbar * )data;
	progressbar_increase(IP, 5);
	if (IP->progress >= IP->MAX) {
		progressbar_text_set(IP, "Dummy download Done!!");
		ecore_timer_add(3, &__dummy_progressbar_free, IP);
		return 0;
	}
	return 1;
}

void dummy_progressbar_new() {
	struct Installer_Progressbar * IP = new_Progressbar(ecore_evas_get(ee), "dummy downloading");
	ecore_timer_add(0.1, &__dummy_progressbar_timer, IP);
}

void dummy_alert_new() {
	new_Alert(ecore_evas_get(ee), "InStAlL", "MeSsAgE", "YeS", "NoP", NULL);
}


void pk_dummy_get_package_cb(void *data, DBusMessage *message) {
	DBusError _err;
	char * tid;
	char * info;
	char * packageid;
	char * summary;
	debug("Get Package!!\n");
	dbus_error_init(&_err);
	if (!dbus_message_get_args(message, &_err,
	                           DBUS_TYPE_STRING, &tid,
	                           DBUS_TYPE_STRING, &info,
	                           DBUS_TYPE_STRING, &packageid,
	                           DBUS_TYPE_STRING, &summary,
	                           DBUS_TYPE_INVALID
	                          )) {
		error("error message: '%s'\n", _err.message);
		return;
	}
	dbus_error_free(&_err);
	debug("tid: '%s'\n", tid);
	debug("info: '%s'\n", info);
	debug("packageid: '%s'\n", packageid);
	debug("Summary: '%s'\n\n", summary);
}

void pk_dummy_search_name(char *name) {
	debug("Search package %s\n", name);
	e_dbus_proxy_connect_signal(pk_proxy(), "Package", (E_DBus_Signal_Cb)pk_dummy_get_package_cb, NULL);
	pk_search_name(NULL, name);
}
